package family;

/** Quick-and-dirty implementation. */

public class Person {

	public String name;     // not null
	public boolean isMale;
	public int birth;       // year
	public Integer death;   // year; null means alive

	public Person( String name, boolean isMale, int birth ){
		this(name,isMale,birth,null);
	}

	public Person( String name, boolean isMale, int birth, int death ){
		this(name,isMale,birth,new Integer(death));
	}

	public Person( String name, boolean isMale, int birth, Integer death ){
		if( name == null )
			throw new IllegalArgumentException("Null name is disallowed");
		this.name = name;
		this.isMale = isMale;
		this.birth = birth;
		this.death = death;
	}

	public @Override Person clone(){
		try { return (Person)super.clone(); }
		catch( CloneNotSupportedException e ){
			assert false;
			return null;
		}
	}

	public @Override boolean equals( Object o ){
		if( o instanceof Person ){
			Person op = (Person)o;
			return name.equals(op.name) && isMale==op.isMale && birth == op.birth && (death == null ? op.death==null : death.equals(op.death));
		} else { return false; }
	}

	public @Override int hashCode(){
		return name.hashCode()+birth;
	}

	public @Override String toString(){
		return name + (isMale ? " (M) " : " (F) ") + birth + (death==null ? "" : "-"+death);
	}

}
